#ifndef _INCLUDED_PHGEOMETRY_H
#define _INCLUDED_PHGEOMETRY_H

#include <Foundation/NSGeometry.h>

@class NSAffineTransform;

NSPoint PHMovePoint(NSPoint pt, float dx, float dy);
NSPoint PHIntegralPoint(NSPoint pt);
NSRect PHRectFromPoints(NSPoint a, NSPoint b);
float PHDistance(NSPoint a, NSPoint b);
NSPoint PHClosestPointInRect(NSPoint pt, NSRect rc);
NSPoint PHClosestPointOnRectEdge(NSPoint pt, NSRect rc);
NSRect PHPushRectInsideBoundaries(NSRect aRect, NSRect bound);
NSAffineTransform * PHReverseTransform(NSAffineTransform * xform);

typedef struct _Vect2D
{
    float dx;
    float dy;
} Vect2D;

static inline Vect2D PHMakeVect2D(float dx, float dy)
{
    Vect2D vect;
    
    vect.dx = dx;
    vect.dy = dy;
    return vect;
}

Vect2D PHBoundVect2D(NSPoint start, Vect2D v, NSRect rc);

static inline NSPoint PHMovePointByVect(NSPoint pt, Vect2D offset)
{
    return NSMakePoint(pt.x + offset.dx, pt.y + offset.dy);
}

typedef struct _Interval
{
    float min;
    float max;
} Interval;

NSString * PHStringFromInterval(Interval intvl);

#endif // _INCLUDED_PHGEOMETRY_H
